﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.IO;

public partial class Simple_ClientCallBack : System.Web.UI.Page, ICallbackEventHandler
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            String cbReference = ClientScript.GetCallbackEventReference(this, "arg", "Demo3_CB", "context");
            String callbackScript = "function Demo3(arg, context) {" +
                cbReference + "; }";
            Page.ClientScript.RegisterClientScriptBlock(this.GetType(),
                "Demo3", callbackScript, true);
        }
    }

    #region ICallbackEventHandler Member
    private string _callbackArg;
    public string GetCallbackResult()
    {
        if (_callbackArg == "xml")
        {
            return GetXml();
        }
        else if (_callbackArg == "json")
        {
            return GetJSON();
        }
        throw new Exception("The method or operation is not implemented.");
    }

    public void RaiseCallbackEvent(string eventArgument)
    {
        _callbackArg = eventArgument;
    }
    private string GetXml()
    {
        XmlDocument xml = new XmlDocument();
        XmlElement dates = xml.CreateElement("dates");
        xml.AppendChild(dates);
        XmlElement full = xml.CreateElement("full");
        full.InnerText = DateTime.Now.ToString();
        XmlElement shortDate = xml.CreateElement("shortDate");
        shortDate.InnerText = DateTime.Now.ToShortDateString();
        dates.AppendChild(full);
        dates.AppendChild(shortDate);
        StringWriter sw = new StringWriter();
        XmlTextWriter tw = new XmlTextWriter(sw);
        tw.Indentation = 4;
        tw.Formatting = Formatting.Indented;
        dates.WriteTo(tw);
        return sw.ToString();
    }
    private string GetJSON()
    {
        return @"
        jsonTempVarName = 
        {
            Vorname  : 'Albert',
            Nachname : 'Weinert',
            Homepage : 'http://der-albert.com',
            Mails    : ['info@der-albert.com', 'albert.weinert@awn-design.biz', 'awn@gmx.de']                     
        };
        ";
    }
    #endregion
}
